// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "__call_policies.pypp.hpp"
#include "__convenience.pypp.hpp"
#include "PythonCoreList.h"
#include "ResolutionFunction2DGaussian.pypp.h"

namespace bp = boost::python;

struct ResolutionFunction2DGaussian_wrapper : ResolutionFunction2DGaussian, bp::wrapper< ResolutionFunction2DGaussian > {

    ResolutionFunction2DGaussian_wrapper(double sigma_x, double sigma_y )
    : ResolutionFunction2DGaussian( sigma_x, sigma_y )
      , bp::wrapper< ResolutionFunction2DGaussian >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::ResolutionFunction2DGaussian * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->ResolutionFunction2DGaussian::clone(  );
        }
    }
    
    ::ResolutionFunction2DGaussian * default_clone(  ) const  {
        return ResolutionFunction2DGaussian::clone( );
    }

    virtual double evaluateCDF( double x, double y ) const  {
        if( bp::override func_evaluateCDF = this->get_override( "evaluateCDF" ) )
            return func_evaluateCDF( x, y );
        else{
            return this->ResolutionFunction2DGaussian::evaluateCDF( x, y );
        }
    }
    
    double default_evaluateCDF( double x, double y ) const  {
        return ResolutionFunction2DGaussian::evaluateCDF( x, y );
    }

    virtual bool areParametersChanged(  ) {
        if( bp::override func_areParametersChanged = this->get_override( "areParametersChanged" ) )
            return func_areParametersChanged(  );
        else{
            return this->IParameterized::areParametersChanged(  );
        }
    }
    
    bool default_areParametersChanged(  ) {
        return IParameterized::areParametersChanged( );
    }

    virtual void clearParameterPool(  ) {
        if( bp::override func_clearParameterPool = this->get_override( "clearParameterPool" ) )
            func_clearParameterPool(  );
        else{
            this->IParameterized::clearParameterPool(  );
        }
    }
    
    void default_clearParameterPool(  ) {
        IParameterized::clearParameterPool( );
    }

    virtual ::ParameterPool * createParameterTree(  ) const  {
        if( bp::override func_createParameterTree = this->get_override( "createParameterTree" ) )
            return func_createParameterTree(  );
        else{
            return this->IParameterized::createParameterTree(  );
        }
    }
    
    ::ParameterPool * default_createParameterTree(  ) const  {
        return IParameterized::createParameterTree( );
    }

    virtual void printParameters(  ) const  {
        if( bp::override func_printParameters = this->get_override( "printParameters" ) )
            func_printParameters(  );
        else{
            this->IParameterized::printParameters(  );
        }
    }
    
    void default_printParameters(  ) const  {
        IParameterized::printParameters( );
    }

    virtual void registerParameter( ::std::string const & name, double * parpointer, ::AttLimits const & limits=AttLimits::limitless( ) ) {
        namespace bpl = boost::python;
        if( bpl::override func_registerParameter = this->get_override( "registerParameter" ) ){
            bpl::object py_result = bpl::call<bpl::object>( func_registerParameter.ptr(), name, parpointer, limits );
        }
        else{
            IParameterized::registerParameter( name, parpointer, boost::ref(limits) );
        }
    }
    
    static void default_registerParameter( ::IParameterized & inst, ::std::string const & name, long unsigned int parpointer, ::AttLimits const & limits=AttLimits::limitless( ) ){
        if( dynamic_cast< ResolutionFunction2DGaussian_wrapper * >( boost::addressof( inst ) ) ){
            inst.::IParameterized::registerParameter(name, reinterpret_cast< double * >( parpointer ), limits);
        }
        else{
            inst.registerParameter(name, reinterpret_cast< double * >( parpointer ), limits);
        }
    }

    virtual bool setParameterValue( ::std::string const & name, double value ) {
        if( bp::override func_setParameterValue = this->get_override( "setParameterValue" ) )
            return func_setParameterValue( name, value );
        else{
            return this->IParameterized::setParameterValue( name, value );
        }
    }
    
    bool default_setParameterValue( ::std::string const & name, double value ) {
        return IParameterized::setParameterValue( name, value );
    }

    virtual void setParametersAreChanged(  ) {
        if( bp::override func_setParametersAreChanged = this->get_override( "setParametersAreChanged" ) )
            func_setParametersAreChanged(  );
        else{
            this->IParameterized::setParametersAreChanged(  );
        }
    }
    
    void default_setParametersAreChanged(  ) {
        IParameterized::setParametersAreChanged( );
    }

    PyObject* m_pyobj;

};

void register_ResolutionFunction2DGaussian_class(){

    { //::ResolutionFunction2DGaussian
        typedef bp::class_< ResolutionFunction2DGaussian_wrapper, bp::bases< IResolutionFunction2D >, std::auto_ptr< ResolutionFunction2DGaussian_wrapper >, boost::noncopyable > ResolutionFunction2DGaussian_exposer_t;
        ResolutionFunction2DGaussian_exposer_t ResolutionFunction2DGaussian_exposer = ResolutionFunction2DGaussian_exposer_t( "ResolutionFunction2DGaussian", bp::init< double, double >(( bp::arg("sigma_x"), bp::arg("sigma_y") )) );
        bp::scope ResolutionFunction2DGaussian_scope( ResolutionFunction2DGaussian_exposer );
        { //::ResolutionFunction2DGaussian::clone
        
            typedef ::ResolutionFunction2DGaussian * ( ::ResolutionFunction2DGaussian::*clone_function_type)(  ) const;
            typedef ::ResolutionFunction2DGaussian * ( ResolutionFunction2DGaussian_wrapper::*default_clone_function_type)(  ) const;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "clone"
                , clone_function_type(&::ResolutionFunction2DGaussian::clone)
                , default_clone_function_type(&ResolutionFunction2DGaussian_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::ResolutionFunction2DGaussian::evaluateCDF
        
            typedef double ( ::ResolutionFunction2DGaussian::*evaluateCDF_function_type)( double,double ) const;
            typedef double ( ResolutionFunction2DGaussian_wrapper::*default_evaluateCDF_function_type)( double,double ) const;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "evaluateCDF"
                , evaluateCDF_function_type(&::ResolutionFunction2DGaussian::evaluateCDF)
                , default_evaluateCDF_function_type(&ResolutionFunction2DGaussian_wrapper::default_evaluateCDF)
                , ( bp::arg("x"), bp::arg("y") ) );
        
        }
        { //::ResolutionFunction2DGaussian::getSigmaX
        
            typedef double ( ::ResolutionFunction2DGaussian::*getSigmaX_function_type)(  ) const;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "getSigmaX"
                , getSigmaX_function_type( &::ResolutionFunction2DGaussian::getSigmaX ) );
        
        }
        { //::ResolutionFunction2DGaussian::getSigmaY
        
            typedef double ( ::ResolutionFunction2DGaussian::*getSigmaY_function_type)(  ) const;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "getSigmaY"
                , getSigmaY_function_type( &::ResolutionFunction2DGaussian::getSigmaY ) );
        
        }
        { //::IParameterized::areParametersChanged
        
            typedef bool ( ::IParameterized::*areParametersChanged_function_type)(  ) ;
            typedef bool ( ResolutionFunction2DGaussian_wrapper::*default_areParametersChanged_function_type)(  ) ;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "areParametersChanged"
                , areParametersChanged_function_type(&::IParameterized::areParametersChanged)
                , default_areParametersChanged_function_type(&ResolutionFunction2DGaussian_wrapper::default_areParametersChanged) );
        
        }
        { //::IParameterized::clearParameterPool
        
            typedef void ( ::IParameterized::*clearParameterPool_function_type)(  ) ;
            typedef void ( ResolutionFunction2DGaussian_wrapper::*default_clearParameterPool_function_type)(  ) ;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "clearParameterPool"
                , clearParameterPool_function_type(&::IParameterized::clearParameterPool)
                , default_clearParameterPool_function_type(&ResolutionFunction2DGaussian_wrapper::default_clearParameterPool) );
        
        }
        { //::IParameterized::createParameterTree
        
            typedef ::ParameterPool * ( ::IParameterized::*createParameterTree_function_type)(  ) const;
            typedef ::ParameterPool * ( ResolutionFunction2DGaussian_wrapper::*default_createParameterTree_function_type)(  ) const;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "createParameterTree"
                , createParameterTree_function_type(&::IParameterized::createParameterTree)
                , default_createParameterTree_function_type(&ResolutionFunction2DGaussian_wrapper::default_createParameterTree)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::IParameterized::printParameters
        
            typedef void ( ::IParameterized::*printParameters_function_type)(  ) const;
            typedef void ( ResolutionFunction2DGaussian_wrapper::*default_printParameters_function_type)(  ) const;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "printParameters"
                , printParameters_function_type(&::IParameterized::printParameters)
                , default_printParameters_function_type(&ResolutionFunction2DGaussian_wrapper::default_printParameters) );
        
        }
        { //::IParameterized::registerParameter
        
            typedef void ( *default_registerParameter_function_type )( ::IParameterized &,::std::string const &,long unsigned int,::AttLimits const & );
            
            ResolutionFunction2DGaussian_exposer.def( 
                "registerParameter"
                , default_registerParameter_function_type( &ResolutionFunction2DGaussian_wrapper::default_registerParameter )
                , ( bp::arg("inst"), bp::arg("name"), bp::arg("parpointer"), bp::arg("limits")=AttLimits::limitless( ) ) );
        
        }
        { //::IParameterized::setParameterValue
        
            typedef bool ( ::IParameterized::*setParameterValue_function_type)( ::std::string const &,double ) ;
            typedef bool ( ResolutionFunction2DGaussian_wrapper::*default_setParameterValue_function_type)( ::std::string const &,double ) ;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "setParameterValue"
                , setParameterValue_function_type(&::IParameterized::setParameterValue)
                , default_setParameterValue_function_type(&ResolutionFunction2DGaussian_wrapper::default_setParameterValue)
                , ( bp::arg("name"), bp::arg("value") ) );
        
        }
        { //::IParameterized::setParametersAreChanged
        
            typedef void ( ::IParameterized::*setParametersAreChanged_function_type)(  ) ;
            typedef void ( ResolutionFunction2DGaussian_wrapper::*default_setParametersAreChanged_function_type)(  ) ;
            
            ResolutionFunction2DGaussian_exposer.def( 
                "setParametersAreChanged"
                , setParametersAreChanged_function_type(&::IParameterized::setParametersAreChanged)
                , default_setParametersAreChanged_function_type(&ResolutionFunction2DGaussian_wrapper::default_setParametersAreChanged) );
        
        }
    }

}
